﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Infragistics.Documents.Excel;
using System.Diagnostics;


namespace DataGridExportToExcelStylesColumns
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.CellExporting += new EventHandler<CellExportingEventArgs>(exporter_CellExporting);
            exporter.Export(this.xamDataGrid1, "xamDataGrid1.xlsx", WorkbookFormat.Excel2007);
            Process.Start("xamDataGrid1.xlsx");
        }

        void exporter_CellExporting(object sender, CellExportingEventArgs e)
        {
            if (e.Field.Settings.EditorStyle.Setters.OfType<Setter>().FirstOrDefault(setter => setter.Property.Name == "Format").Value.ToString() == "#,###")
            {
                e.FormatSettings.FormatString = "#,###";
            }
            else if (e.Field.Settings.EditorStyle.Setters.OfType<Setter>().FirstOrDefault(setter => setter.Property.Name == "Format").Value.ToString() == "N")
            {
                e.FormatSettings.FormatString = "#,##0.00";
            }
        }
    }
}